#include <fstream>
#include <vector>
#include <queue>
#include <algorithm>
using namespace std;

ifstream fin("labir.in");
ofstream fout("labir.out");

struct Pair {
    int x, y;
};

using VI = vector<int>;
using VVI = vector<VI>;
using VP = vector<Pair>;
using VB = vector<bool>;
using VVB = vector<VB>;

const int di[] {-1, 0, 1,  0};
const int dj[] { 0, 1, 0, -1};
const int inf = 0x3f3f3f3f;

VP vp;
VI sx, sy;
VVB mat;
VVI c;
deque<Pair> q;
bool xlimit, ylimit;
int N, M, k, x, y, xi, yi, xf, yf, xmax, ymax, n, m;

bool ok(int i, int j)
{
	return i >= 1 && i <= n && j >= 1 && j <= m;
}
void BF01()
{
    int iv, jv, i, j;
    c = VVI(n + 1, VI(m + 1, inf));
    c[xi][yi] = mat[xi][yi];
    
    q.push_back({xi, yi});
    
    while (!q.empty())
    {
        i = q.front().x;
        j = q.front().y;
        q.pop_front();
        for (int dir = 0; dir < 4; ++dir)
        {
            iv = i + di[dir];
            jv = j + dj[dir];
            if (ok(iv, jv))
                if (c[iv][jv] > c[i][j] + mat[iv][jv])
                {
                    c[iv][jv] = c[i][j] + mat[iv][jv];
                    if (mat[iv][jv] == 0)
                        q.push_front({iv, jv});
                    else q.push_back({iv, jv});
                }
        }
    }
}

int main()
{
    fin >> N >> M >> xi >> yi >> xf >> yf >> k;
    vp = VP(k + 1);
    
    sx.push_back(xi), sy.push_back(yi);
    sx.push_back(xf), sy.push_back(yf);
    xmax = max(xi, xmax);
    xmax = max(xf, xmax);
    ymax = max(yi, ymax);
    ymax = max(yf, ymax);
    
    for (int i = 1; i <= k; ++i)
    {
        fin >> x >> y;
        xmax = max(x, xmax);
        ymax = max(y, ymax);
        sx.push_back(x - 1), sx.push_back(x);
        sy.push_back(y - 1), sy.push_back(y);
        vp[i] = {x, y};
    }
    if (xmax == N)
        xlimit = true;
    if (ymax == M)
        ylimit = true;
    sx.push_back(0), sy.push_back(0);
    sort(sx.begin(), sx.end());
    sx.erase(unique(sx.begin(), sx.end()), sx.end());
    sort(sy.begin(), sy.end());
    sy.erase(unique(sy.begin(), sy.end()), sy.end());
    n = (int)sx.size() - 1;
    m = (int)sy.size() - 1;
    if (!xlimit) ++n;
    if (!ylimit) ++m;
    mat = VVB(n + 1, VB(m + 1));
    for (int i = 1; i <= k; ++i)
    {
        x = lower_bound(sx.begin(), sx.end(), vp[i].x) - sx.begin();
        y = lower_bound(sy.begin(), sy.end(), vp[i].y) - sy.begin();
        mat[x][y] = 1;
    }
    xi = lower_bound(sx.begin(), sx.end(), xi) - sx.begin();
    xf = lower_bound(sx.begin(), sx.end(), xf) - sx.begin();
    yi = lower_bound(sy.begin(), sy.end(), yi) - sy.begin();
    yf = lower_bound(sy.begin(), sy.end(), yf) - sy.begin();
    
    
    BF01();
    fout << c[xf][yf];

    fin.close();
    fout.close();
    return 0;
}
