// NORMALIZARE - elemente de la poz 0
#include <vector>
#include <iostream>
#include <iomanip>
#include <fstream>
using namespace std;

ifstream fin("norm_sir.in");
ofstream fout("norm_sir.out");
	
int n;
using VI = vector<int>;

void Print(VI& v)
{
	for (const int& x : v)
		fout << setw(3) << x;
	fout << '\n';
}


int main()
{
	
	fin >> n;
	VI a(n);
	
	for(int i = 0; i < n; i++) 
		fin >> a[i];
	
	// NORMALIZARE SIR
	VI b (a);
	sort(b.begin(), b.end()); // O(n * log2(n))
//	b = 10 10 20 55 55 65 65 
// dupa unique:
//  b = 10 20 55 65  10 65 55 
//                   it       end()
	auto it = unique(b.begin(), b.end());
	b.erase(it, b.end()); // idiomul erase-unque
	
// acum b = {10,   20,    55, 65}	
//         beg() beg()+1 beg()+2
	VI c(n);
	for(int i = 0; i < n; i++)  // O(n * log2(n))
		c[i] = lower_bound(b.begin(), b.end(), a[i]) - b.begin() + 1;
// lower_bound returneaza un iterator la primul elem din b[] care NU e mai mic
// decat a[i]
	Print(a);
	Print(c);
    
    return 0;
}
